import random
import sys

# we generate #s samples for each #e-edge and #n nodes graph(3-layer graph).
#n is node number. 
#e is the edge number.
#s is how many sample for each edge.

n=int(sys.argv[1])
e=int(sys.argv[2])
s=int(sys.argv[3])

'''
n=300
delete_edges=range(20,100,10)
samples=range(1,20)

for e in delete_edges:
	for s in samples:

'''
with open('./inst/inst'+str(n)+"_"+str(e)+"_"+str(s),'w') as f:
	
	# n=3*2*k
	# It is a three-layer graph. So n is a multiplier of 3.
	# We notice that only even node graphs in each layer have hamiltonian cycle, so it must be the multiplier of 2.
	n=int(n)/3/2*2*3

	#write n nodes.
	for i in range(n+1)[1:]:
		f.write('node('+str(i)+').\n')

	#generate structured graph : 3-layer graphs

	dic={}
	#the commments are based on 300 nodes.
	nodeOfLayer=n/3  #nodeOfLayer=100 when node=300

	#1. for each layer, generate bi-directioned edges: (1,2),(2,1),(2,3),(3,2)...
	for node in range(1,n):
		#there are some breaks for nodes in two layers like (100,101),(200,201) 
		if not node%nodeOfLayer ==0:					
			key=str(node)+','+str(node+1)
			key2=str(node+1)+','+str(node)
			dic[key]=1
			dic[key2]=1
	#2. vertical edge:(1,101),(101,1),(101,201),(201,101)..(200,300),(300,200)
	for node in range(1,1+n-nodeOfLayer):	#1 to 200, when n=300	
		#add(1,101)...(200,300)
		key=str(node)+','+str(nodeOfLayer+node)
		#(101,1),...(300,200)
		key2=str(node+nodeOfLayer)+','+str(node)
		dic[key]=1
		dic[key2]=1			
	#print len(dic)
	#3. randomly delete #delete_edges edges.
	numberOfEdgeDlt=0
	while True:
		randlist=random.sample(range(1,n+1),2)
		if randlist[0]!=randlist[1]:
			key=str(randlist[0])+','+str(randlist[1])
			if key in dic:
				del dic[key]
				numberOfEdgeDlt +=1
			if numberOfEdgeDlt==e:
				break
			if len(dic)==0:
				break

	sortdic=sorted([k for k in dic])
	#write keys in the file;
	#only key matters.
	for i in sortdic:
		f.write('link('+i+').\n')
	#print n,len(dic)
